module hashtable;

extern (C) {
	int NXNextHashState(NXHashTable *table, NXHashState *state, void** data);
	NXHashState NXInitHashState(NXHashTable *table);

	struct NXHashTablePrototype {
		uint (*hash)(void* info, void* data);
		int (*isEqual)(void* info, void* data);
		void (*free)(void* info, void* data);
		int style;
	}

	struct NXHashTable {
		NXHashTablePrototype *prototype;
		uint count;
		uint nbBuckets;
		void* buckets;
		void* info;
	}
	
	struct NXHashState {
		int i;
		int j;
	}
}
